/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <y5t0964@students.chiba-u.ac.jp>
 */


/* Xatm.h */

#ifndef _XATM_H
#define _XATM_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>

#include <X11/Xos.h>

#define XtNumber(arr) ((unsigned int) (sizeof(arr) / sizeof(arr[0])))

#include "fntfilst.h"

#include "Xatm_struct.h"
#include "metric.h"

/* bool */
#define XATM_TRUE 1
#define XATM_FALSE 0

/* Xatm ǧեȤγĥ */
#define XATM_EXT      ".atm"
#define XATM_EXT_LEN  4

#define XATM_EXT_I      ".atm-i"
#define XATM_EXT_LEN_I  6


/* ghostscript ưλޤǤԤ */
#define GS_WAIT_SEC 60

Bool FontFileRegisterRenderer (FontRendererPtr renderer);
void BitOrderInvert(register unsigned char *buf, register int nbytes);
void TwoByteSwap(register unsigned char *buf, register int nbytes);
void FourByteSwap(register unsigned char *buf, register int nbytes);
int CheckFSFormat(fsBitmapFormat format,
		  fsBitmapFormatMask fmask,
		  int *bit_order,
		  int *byte_order,
		  int *scan,
		  int *glyph,
		  int *image);
Atom MakeAtom(char *string, unsigned len, int makeit);
int FontDefaultFormat (int *bit, int *byte, int *glyph, int *scan);
            /* δؿ void ˸Τ... -> fontfile/defaults.c */
void CleanupChild(int n); /* programs/xfs/os/utils.c */


/* δؿϼºݤȰ㤦, ưϤ */
void *Xalloc (int m);
void *Xrealloc (void *n, int m);
void Xfree (void *n);



/* fcntl.c */
void xatm_nonblock(int fd);
void xatm_block(int fd);
void xatm_flush(int fd);

/* string_ut.c */
char * strcasestr(char *haystack, const char *needle);

/* pool.c */
CharInfoPoolPtr CharInfoPool_Alloc(int bitmapSize);
CharInfoPtr CharInfoPool_Get(CharInfoPoolPtr this);
void CharInfoPool_Free(CharInfoPoolPtr this);

/* Xatm_funcs.c */
int XatmOpenScalable(FontPathElementPtr fpe,
		     FontPtr	    *pFont,
		     int                flags,
		     FontEntryPtr       entry,
		     char               *fileName,
		     FontScalablePtr    vals,
		     fsBitmapFormat     format,
		     fsBitmapFormatMask fmask,
		     FontPtr            non_cachable_font);
int XatmGetInfoScalable(FontPathElementPtr  fpe,
			FontInfoPtr	        pFontInfo,
			FontEntryPtr        entry,
			FontNamePtr	        pFontName,
			char	        *fileName,
			FontScalablePtr	vals);
void XatmRegisterFontFileFunctions(void);


/* gs.c */
void gsInit(void);
void gsDeinit(int i);
typedef struct _gspipe {
	int r;            /* xfs <== gs */
	int w;            /* xfs ==> gs */
	char init;        /* gs ư줿Ф꤫? */
} GsPipe;
GsPipe gsGetPipe(void);
void gsAtExit(void);


/* italic.c */
int XatmOpenScalable_italic(FontPathElementPtr fpe,
			    FontPtr	           *pFont,
			    int                flags,
			    FontEntryPtr       entry,
			    char               *fileName,
			    FontScalablePtr    vals,
			    fsBitmapFormat     format,
			    fsBitmapFormatMask fmask,
			    FontPtr            non_cachable_font);
int XatmGetInfoScalable_italic(FontPathElementPtr  fpe,
			       FontInfoPtr	       pFontInfo,
			       FontEntryPtr        entry,
			       FontNamePtr	       pFontName,
			       char	               *fileName,
			       FontScalablePtr     vals);

#endif
