/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <y5t0964@students.chiba-u.ac.jp>
 */

/* This code is derived from X-VFlib's btree.h */

/*****************************************************************
 * B-Tree
 */

/*$Id: btree.h,v 1.4 1998/05/31 15:06:22 elca Exp $*/

#ifndef _BTREE_H_
#define _BTREE_H_

#define BTreeHalfSize 4

typedef struct _NodeRec {
	int key;
	void *value;
} NodeRec, *NodePtr;

typedef struct _PageRec {
	int n;
	NodeRec node[BTreeHalfSize * 2];
	struct _PageRec *branch[BTreeHalfSize * 2 + 1];
} PageRec, *PagePtr;

typedef struct _BTree {
/* private */
	NodeRec node;
	PagePtr page;
	int del, under;
/* public */
	PagePtr root;
} BTreeRec, *BTreePtr;

extern BTreePtr BTree_Alloc();
extern int BTree_Search(BTreePtr this, int key, void **value);
extern void BTree_Insert(BTreePtr this, int key, void *value);
extern void BTree_Free(BTreePtr this);
extern void BTree_Print(BTreePtr this);

#endif /* _BTREE_H_ */

/*
 * End Of File
 */
