/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <y5t0964@students.chiba-u.ac.jp>
 */

/* gs.c -- ghostscript  */
/* $Id: gs.c,v 1.7 1998/06/05 00:11:17 elca Exp elca $ */

#include <unistd.h>
#include <sys/stat.h>
#include "Xatm.h"

/*#define dprintf(str) fprintf str*/
#define dprintf(str) /* */

static int gsPid = 0;
static int gs[2][2]; /* ghostscript Ȥ̿
			[0][1] xfs ---> gs [0][0]
			[1][0] xfs <--- gs [1][1]
			*/


/* ghostscript εưȽ */
void gsInit(void)
{
	dprintf((stdout, "gsinit\n"));

	/* ghostscript Ȥ̿ */
	if(pipe(gs[0]) != 0) {
		printf("gs[0] pipe error\n");
		exit(1);
	}
	if(pipe(gs[1]) != 0) {
		printf("gs[1] pipe error\n");
		exit(1);
	}
	switch(gsPid = fork()) {
	case -1:
		printf("fork gs error\n");
		exit(1);
		break;
	case 0:
		/* gs -> xfs ؤ̿ */
		close(STDIN_FILENO);
		dup(gs[0][0]);
		close(STDOUT_FILENO);
		dup(gs[1][1]);

		close(gs[0][0]);
		close(gs[0][1]);
		close(gs[1][0]);
		close(gs[1][1]);

		/* ghostscript ư */
		/* gs -dSAFER -sDEVICE=bit -sOutputFile=- -q -dNOPAUSE
		    -c "/.setpagesize { //systemdict /statusdict get begin .setpagesize end } bind def"
		    - */
		execlp("gs", "gs", "-dSAFER", "-sDEVICE=bit", "-sOutputFile=-",
		       "-q", "-dNOPAUSE",
		       "-c",
		       "/.setpagesize { //systemdict /statusdict get begin .setpagesize end } bind def",
		       "-", NULL);
		printf("execlp gs error\n");
		exit(1);
	default:
		/* xfs -> gs ؤ̿ʳϺ */
		close(gs[0][0]);
		close(gs[1][1]);
		break;
	}

	xatm_nonblock(gs[1][0]);

}

/* ghostscript λ */
void gsDeinit(int i)
{
	alarm(0); /* ޡ */

	xatm_flush(gs[1][0]);

	dprintf((stdout, "gsquit\n"));

	write(gs[0][1], "quit\n", strlen("quit\n"));

	gsPid = 0;

	/* ̿Ĥ */
	close(gs[0][1]);
	close(gs[1][0]);

	signal(SIGALRM, gsDeinit); /* ʥϥɥ */
}

/* ghostscript ³줿 եǥץ֤ */
GsPipe gsGetPipe(void)
{
	GsPipe ret;
#if 0
	struct stat s;
	char dirname[128]; /* XXX */
#endif

	dprintf((stdout, __FUNCTION__ "\n"));


	if(gsPid == 0) { /* ghostscript ưƤʤ */
		gsInit();
		ret.init = XATM_TRUE;
	} else {
		ret.init = XATM_FALSE;
	}
#if 0
	sprintf(dirname, "/proc/%d", gsPid);
	if(stat(dirname, &s) != 0) { /* ghostscript ۾ｪλβ */
		printf("gs not responding. cleanup & restart gs.\n");
		alarm(0);
		close(gs[1][0]);
		close(gs[0][1]);
		gsPid = 0;
		gsInit();
	}
#endif

	dprintf((stdout, "pid: %d\n", gsPid));

	ret.r = gs[1][0];
	ret.w = gs[0][1];

	return ret;
}


/* xfs νλ ghostscript λ */
void gsAtExit(void)
{
	int i = 0;

	if(gsPid == 0) {
		return; /* Ǥ ghostscript ϽλƤ */
	}

	gsDeinit(i);
}

/* end */
